/* 
    GALROID/V 
    v0.1a (G9I.0873)
    <http://laemeur.com/galroid-v/>

    By LÆMEUR <adam@laemeur.com>

    This game is free software and is distributed under the terms of
    the GNU General Public License,
    <https://www.gnu.org/copyleft/gpl.html>

*/
var canvasElement = document.getElementById("phosphor");
var DVG = canvasElement.getContext("2d");
var bgimg = document.getElementById("bgimg");
var screenWidth = 960;
var screenHeight = 720;
canvasElement.width = screenWidth; //window.innerWidth;
canvasElement.height = screenHeight; //window.innerHeight;
bufferWidth = canvasElement.width * 4;
bufferDepth = bufferWidth * canvasElement.height;
maxOps = 1;
pDecay = 0.7;
shimmer = 20;
lastPoint = new Object();
lastPoint.x = 0;
lastPoint.y = 0;
vps = document.getElementById("vps");
decay = document.getElementById("decay");
jitter = 0;
var mainTime = document.getElementById("main_time");
var dvgTime = document.getElementById("dvg_time");
// =============================================
var pc = 0;                // Program Counter
var stack = new Array();   // Stack
var program = new Array(); // Program memory
var HALT_FLAG = 0;         // 
var SCALE_FACTOR = 0;      //
var lastIntensity = 8;
// =============================================
//var intWidths1 = [1, 1, 1, 1, 1, 1, 1, 1, 
//		  1, 1.1, 1.2, 1.3, 1.4, 1.5, 1.7, 3];
var intWidths1 = [1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 1.5, 
		  1.5, 1.75, 2, 2.33, 2.66, 3, 3.5, 4];
var intWidths2 = [3, 3, 3, 3, 3, 3, 3, 3,
		  3, 3.1, 3.2, 3.3, 4, 5, 6, 8];
var intWidths3 = [6, 6, 6, 6, 6, 6, 6, 6,
		  6, 6.1, 6.3, 6.5, 6.8, 7.2, 7.6, 12];
var intBright1 = [0.0,0.1,0.2,0.3,0.4,0.5,0.6,0.7,
		  0.8,0.81,0.82,0.83,0.84,0.85,0.86,1];
var intBright2 = [0.0,0.05,0.1,0.15,0.2,0.25,0.3,0.3,
		  0.3,0.31,0.32,0.33,0.34,0.36,0.38,0.6];
var intBright3 = [0.0,0.01,0.02,0.03,0.05,0.06,0.07,0.2,
		  0.1,0.11,0.12,0.13,0.14,0.15,0.16,0.17];
var divisors = [1,2,4,8,16,32,64,128,256,512];
var scalers = [0, 2, 4, 8, 16, 32, 64, 128, 
	       0.00390625, 0.0078125, 0.15625, 0.3125, 
	       0.0625, 0.125, 0.25, 0.5];
// Default (empty) program
program.push(new vecOp("LABS"));
program.push(new vecOp("VCTR",0,30));
program.push(new vecOp("JMPL",0));

//================================================
// GAME VARIABLES
controls = {"left" : false,
	    "right" : false,
	    "thrust" : false,
	    "missile" : false};
var ab = 4; // Asteroid Brightness
var challenge = 0;
var mode = "attract";
var asteroidVectors = [];
asteroidVectors.push([[0,2,0],[2,2,ab],[2,-2,ab],[-1,-2,ab],[1,-2,ab],[-3,-2,ab],
		      [-3,0,ab],[-2,2,ab],[0,4,ab],[2,2,ab],[2,-2,ab]]);
asteroidVectors.push([[0,3,0],[2,1,ab],[2,-2,ab],[-2,-1,ab],[2,-2,ab],[-2,-3,ab],
		      [-3,1,ab],[-1,-1,ab],[-2,2,ab],[1,2,ab],[-1,2,ab],[2,2,ab],[2,-1,ab]]);
asteroidVectors.push([[-1,4,0],[3,0,ab],[2,-3,ab],[0,-2,ab],[-2,-3,ab],[-2,0,ab],[0,3,ab],
		      [-2,-3,ab],[-2,3,ab],[2,1,ab],[-2,1,ab],[3,3,ab]]);
asteroidVectors.push([[1,4,0],[3,-2,ab],[0,-1,ab],[-3,-1,ab],[3,-2,ab],[-2,-2,ab],[-1,1,ab],
		      [-3,-1,ab],[-2,3,ab],[0,3,ab],[3,0,ab],[-1,2,ab],[3,0,ab]]);
var maxShipSpeed = 20;
var maxRoids = 0;
var stageTime = 0;
var scene = [];
var missiles = [];
var inactiveMissiles = [];
var starfield = [];
var sfx = {"boom":document.getElementById("sfxBoom"),
	   "shot":document.getElementById("sfxShot"),
	   "thrust":document.getElementById("sfxThrust"),
	   "beep":document.getElementById("sfxBeep")}
sfx.thrust.loop = true;
var shipImage = new Image();
shipImage.src = "ship.png";
var ship = {x : -999,
	    y : -999,
	    points: 0,
	    power: 3,
	    alive : false,
	    livetime : 0,
	    lives : 0,
	    rot : 0,
	    inertiaX : 0,
	    inertiaY : 0,
	    coords : [[-4,8,0],
		      [-4,-2,12],[4,-3,12],[4,-11,12],
		      [4,11,12],[4,3,12],[-4,2,12],[-8,0,12]],
	    thrustcoords : [[1,4,0],[3,3,10],[3,-3,10]],
	    rotcoords : [],
	    addPoints : function (p){
		this.points += p;
		scoreVector = vectorString(this.points.toString(),20,30,3);
		// FIX POINTS DISPLAY TO BE LESS GARBAGE-INTENSE
	    },
	    displayProgram : function(){
		var rotcoords = [];
		var xError = 0;
		var yError = 0;
		for (var c in this.coords){
		    rotcoords.push(rot(this.coords[c],this.rot));
		    xError += rotcoords[c][0];
		    yError += rotcoords[c][1];
		}
		xError -= rotcoords[0][0];
		yError -= rotcoords[0][1];
		rotcoords[rotcoords.length -1][0] -= xError;
		rotcoords[rotcoords.length -1][1] -= yError;
		if (controls["thrust"]){
		    for (var c in this.thrustcoords){
			rotcoords.push(rot(this.thrustcoords[c],this.rot));
		    }
		}
		var dprog = [new vecOp("LABS",parseInt(this.x),parseInt(this.y),1)];
		for (var c in rotcoords){
		    dprog.push(new vecOp("VCTR",
					 parseInt(rotcoords[c][0]),
					 parseInt(rotcoords[c][1]),
					 1,
					 rotcoords[c][2]));
		}
		return dprog;
		/*DVG.save();
		DVG.globalCompositeOperation = "lighter";
		DVG.translate(this.x,this.y);
		DVG.rotate(this.rot);
		DVG.drawImage(shipImage,-40,-40);
		DVG.restore();
		return [];*/
		
	    },
	    update : function(){
		this.inertiaX = this.inertiaX * 0.98;
		this.inertiaY = this.inertiaY * 0.98;
		this.x += this.inertiaX;
		this.y += this.inertiaY;
		this.x = wrapX(this.x + this.inertiaX);
		this.y = wrapY(this.y + this.inertiaY);
		// Missile collision detect
		for (var m in missiles){
		    if (missiles[m].type == "badmissile"){
			var prox = Math.sqrt(Math.pow(this.x - missiles[m].x,2) +
					     Math.pow(this.y - missiles[m].y,2));
			if (Math.abs(prox) <= 8){
			    playerKill();
			    missiles[m].ttl = 0;			
			    return false;
			}
		    }
		}
	    }};

//scene.unshift(ship);

// -----------------------------------------
// INIT
// -----------------------------------------
for (var ix = 0; ix < 20; ix++){
    starfield.push(new Star());
}

// ==========================================
var vectorLetters = {
    " " : [],
    "a" : [[0,-4,1],[2,-2,1],[2,2,1],[0,4,1],[0,-2,0],[-4,0,1]],
    "b" : [[0,-6,1],[3,0,1],[1,1,1],[0,1,1],[-1,1,1],[-3,0,1],[3,0,0],
	   [1,1,1],[0,1,1],[-1,1,1],[-3,0,1]],
    "c" : [[4,-6,0],[-4,0,1],[0,6,1],[4,0,1]],
    "d" : [[0,-6,1],[2,0,1],[2,2,1],[0,2,1],[-2,2,1],[-2,0,1]],
    "e" : [[4,0,0],[-4,0,1],[0,-6,1],[4,0,1],[0,3,0],[-4,0,1]],
    "f" : [[0,-6,1],[4,0,1],[0,3,0],[-4,0,1]],
    "g" : [[4,-4,0],[0,-2,1],[-4,0,1],[0,6,1],[4,0,1],[0,-2,1],[-2,0,1]],
    "h" : [[0,-6,1],[4,0,0],[0,6,1],[0,-3,0],[-4,0,1]],
    "i" : [[4,0,1],[-2,0,0],[0,-6,1],[-2,0,0],[4,0,1]],
    "j" : [[0,-2,0],[2,2,1],[2,0,1],[0,-6,1]],
    "k" : [[0,-6,1],[4,0,0],[-4,3,1],[4,3,1]],
    "l" : [[0,-6,0],[0,6,1],[4,0,1]],
    "m" : [[0,-6,1],[2,2,1],[2,-2,1],[0,6,1]],
    "n" : [[0,-6,1],[4,6,1],[0,-6,1]],
    "o" : [[4,0,1],[0,-6,1],[-4,0,1],[0,6,1]],
    "p" : [[0,-6,1],[4,0,1],[0,3,1],[-4,0,1]],
    "q" : [[4,0,1],[0,-6,1],[-4,0,1],[0,6,1],[2,-3,0],[2,3,1]],
    "r" : [[0,-6,1],[4,0,1],[0,3,1],[-4,0,1],[1,0,0],[3,3,1]],
    "s" : [[4,0,1],[0,-3,1],[-4,0,1],[0,-3,1],[4,0,1]],
    "t" : [[2,0,0],[0,-6,1],[-2,0,0],[4,0,1]],
    "u" : [[0,-6,0],[0,6,1],[4,0,1],[0,-6,1]],
    "v" : [[0,-6,0],[2,6,1],[2,-6,1]],
    "w" : [[0,-6,0],[0,6,1],[2,-2,1],[2,2,1],[0,-6,1]],
    "x" : [[4,-6,1],[-4,0,0],[4,6,1]],
    "y" : [[2,0,0],[0,-4,1],[-2,-2,1],[4,0,0],[-2,2,1]],
    "z" : [[0,-6,0],[4,0,1],[-4,6,1],[4,0,1]],
    "0" : [[4,0,1],[0,-6,1],[-4,0,1],[0,6,1],[4,-6,1]],
    "1" : [[2,0,0],[0,-6,1]],
    "2" : [[0,-6,0],[4,0,1],[0,3,1],[-4,0,1],[0,3,1],[4,0,1]],
    "3" : [[4,0,1],[0,-6,1],[-4,0,1],[0,3,0],[4,0,1]],
    "4" : [[4,0,0],[0,-6,1],[-4,0,0],[0,3,1],[4,0,1]],
    "5" : [[4,0,1],[0,-3,1],[-4,0,1],[0,-3,1],[4,0,1]],
    "6" : [[4,-6,0],[-4,0,1],[0,6,1],[4,0,1],[0,-3,1],[-4,0,1]],
    "7" : [[0,-6,0],[4,0,1],[0,6,1]],
    "8" : [[4,0,1],[0,-6,1],[-4,0,1],[0,6,1],[0,-3,0],[4,0,1]],
    "9" : [[4,0,0],[0,-6,1],[-4,0,1],[0,3,1],[4,0,1]],
    "." : [[0,0,1]],
    ":" : [[4,-6,1],[-4,0,0],[4,6,1]],
    "/" : [[4,-6,1]],
    "-" : [[0,-3,0],[4,0,1]],
    "_" : [[4,-6,1],[-4,0,0],[4,6,1]]
};

function vectorString(s,x,y,scale) {
    // Give me a string, and I will give you an array of vecOps for
    // drawing it. X and Y locations for the bottom-left corner of the
    // first character can be passed, as well as a scale value. If no
    // X,Y are passed, text will be centered on the screen.
    if (!s) {return []};
    var scale = scale || 2;
    var x = x || parseInt((screenWidth/2) - ((s.length * (6 * scalers[scale-1])) / 2));
    var y = y || screenHeight/2;
    var dprog = [];
    for (var ch = 0; ch < s.length; ch++){
	var character = s.substr(ch,1);
	dprog.push(new vecOp("LABS",x + (ch * (6 * scalers[scale-1])),y,scale));
	if(vectorLetters[character]){
	    dprog = dprog.concat(VCTRize(vectorLetters[character]));
	}
	
    }
    return dprog;
}

function VCTRize(vs){
    // Pass me an array of [xDeflection,yDeflection,beamToggle] arrays,
    // and I'll return an array of VCTR vecOps
    var dp = [];
    for (var v in vs){
	dp.push(new vecOp("VCTR",vs[v][0],vs[v][1],1,(4 * vs[v][2])));
    }
    return dp;
}
var scoreVector = vectorString("0",20,30,3);
var shipsVector = vectorString(0,0,0);

var attractCard = {
    counter : 0,
    dprog1 : vectorString("game over",null,null,3).concat(
	vectorString("copyright 1979 imitari",null,700)),
    dprog2 : vectorString("insert coin",null,null,3).concat(
	vectorString("copyright 1979 imitari",null,700)),
    displayProgram : function(){
	if ((this.counter % 400) < 200){
	    return this.dprog1;
	} else {
	    return this.dprog2;
	}
    },
	update : function(){
	    this.counter++;
	}
}
scene.push(attractCard);
var warpPrompt = {
    displayProgram : function(){
	return vectorString("warp when ready");
    },
    update : function(){}
}
function TimeoutMessage(msg,x,y,scale,ttl){
    this.message = msg || "EMPTY MESSAGE";
    this.x = x || null;
    this.y = y || null;
    this.scale = scale || 2;
    this.ttl = ttl || 30;
    this.dprog = vectorString(this.message,this.x,this.y,this.scale);
    this.displayProgram = function(){
	return this.dprog;
    };
    this.update = function(){
	this.ttl--;
	if (this.ttl < 1) {
	    scene.splice(scene.indexOf(this),1);
	}
    }
}

function StarSpeed(factor){
    this.factor = factor || 1;
    this.ttl = 90;
    this.displayProgram = function(){
	return [];
    };
    this.update = function(){
	this.ttl--;
	if (this.ttl < 1) {
	    scene.splice(scene.indexOf(this),1);
	} else {
	    for (var s in starfield){
		starfield[s].inertiaY = starfield[s].inertiaY * this.factor;
	    }
	}
    }
}

// PLAYER MISSILE ======
function Missile(x,y,v){
    this.type = "goodmissile";
    this.x = x || 0;
    this.y = y || 0;
    this.ttl = 35;
    this.lastx = x;
    this.lasty = y;
    this.inertiaX = Math.sin(v) * 16;
    this.inertiaY = 0 - Math.cos(v) * 16;
    this.displayProgram = function() {
	return [new vecOp("LABS",parseInt(this.x),parseInt(this.y)),
		new vecOp("VCTR",
			  parseInt(this.x - this.lastx),
			  parseInt(this.y - this.lasty),
			  1,15)
	       ];
    };
    this.update = function (){
	this.lastx = this.x;
	this.lasty = this.y;
	this.x = wrapX(this.x + this.inertiaX);
	this.y = wrapY(this.y + this.inertiaY);	
	this.ttl--;
	if(this.ttl < 1){
	    // Missile timed-out.
	    missiles.splice(missiles.indexOf(this),1);
	    if(this.type == "goodmissile"){
		ship.power++;
	    }
	    return false;
	};
	return true;
    };
}
function BadMissile(x,y,v){
    badMissile = new Missile(x,y,v);
    badMissile.type = "badmissile";
    badMissile.ttl = badMissile.ttl * 2;
    badMissile.inertiaX = badMissile.inertiaX * 0.5;
    badMissile.inertiaY = badMissile.inertiaY * 0.5;
    return badMissile;
}

function Star(){
    this.x = parseInt(Math.random()*screenWidth);
    this.y = parseInt(Math.random()*screenHeight);
    this.l = 4; //1 + parseInt(Math.random()*4);
    this.inertiaY = Math.random()*6;
    this.displayProgram = function() {
	return [new vecOp("LABS",parseInt(this.x),parseInt(this.y)),
		new vecOp("VCTR",0,1,1,this.l)
	       ];
    };
    this.update = function (){
	this.y = wrapY(this.y + this.inertiaY);
    };
}

// EXPLOSION PARTICLE ===
function Particle(x,y){
    this.type = "particle";
    this.x = x || 0;
    this.y = y || 0;
    this.ttl = 10 + parseInt(Math.random()*20);
    this.lastx = x;
    this.lasty = y;
    this.inertiaX = 5 - Math.random()*14;
    this.inertiaY = 5 - Math.random()*14;
    this.displayProgram = function() {
	return [new vecOp("LABS",parseInt(this.x),parseInt(this.y)),
		new vecOp("VCTR",
			  parseInt(this.x - this.lastx),
			  parseInt(this.y - this.lasty),
			  1,14)
	       ];
    };
    this.update = function (){
	this.lastx = this.x;
	this.lasty = this.y;
	this.x = wrapX(this.x + this.inertiaX);
	this.y = wrapY(this.y + this.inertiaY);
	this.ttl--;
	if((this.ttl < 1) ||
	   (this.x > screenWidth) ||
	   (this.y > screenHeight) ||
	   (this.x < 0) ||
	   (this.y < 0)){
	    scene.splice(scene.indexOf(this),1);
	    return false;
	};
	return true;
    };
}

// ASTEROID =========
var roidPoints = [0,0,100,50,20];
function Roid(x,y,s){
    this.x = x || 0;
    this.y = y || 0;
    this.scale = s || 4;
    this.inertia = 2 * ((6 - this.scale) + (challenge * 10));
    this.type = "roid";
    this.rot = 0;
    this.rotSpeed = 0.25 * (0.5  - Math.random());
    this.coords = asteroidVectors[parseInt(Math.random()*asteroidVectors.length)];
    this.rotcoords = [];
    this.inertiaX = (0.5 - Math.random()) * this.inertia;
    this.inertiaY = (0.5 - Math.random()) * this.inertia;
    this.dprog = [];
    this.displayProgram = function(){
	this.rotcoords = [];
	for (var c in this.coords){
	    this.rotcoords.push(rot([this.coords[c][0]*(scalers[this.scale-1]),
				     this.coords[c][1]*(scalers[this.scale-1])],
				    this.rot));
	}
	
	this.dprog = [new vecOp("LABS",
			       parseInt(this.x),
			       parseInt(this.y),
			       1)];
	//this.scale)];
	var xError = 0;
	var yError = 0;
	for (var c in this.rotcoords){
	    xError += parseInt(this.rotcoords[c][0]);
	    yError += parseInt(this.rotcoords[c][1]);
	    this.dprog.push(new vecOp("VCTR",
				 parseInt(this.rotcoords[c][0]),
				 parseInt(this.rotcoords[c][1]),
				 1,
				 this.coords[c][2]));
	}
	// Rotating translation coordinates can produce vectors that don't
	// close properly, so here's a kludge to fix that. I should probably just
	// redo the way I'm rotating objects, but this works for the moment.
	xError -= this.dprog[1].x;
	yError -= this.dprog[1].y;
	this.dprog[this.dprog.length - 1].x -= xError;
	this.dprog[this.dprog.length - 1].y -= yError;
	return this.dprog;
    };
    this.update = function(){
	this.rot += this.rotSpeed;
	this.rot = this.rot % 6.28;
	this.x = wrapX(this.x + this.inertiaX);
	this.y = wrapY(this.y + this.inertiaY);
	// Missile collision detect
	for (var m in missiles){
	    if (missiles[m].ttl == 0){continue;};
	    var prox = Math.sqrt(Math.pow(this.x - missiles[m].x,2) +
				 Math.pow(this.y - missiles[m].y,2));
	    if (Math.abs(prox) <= 2 + 4 * scalers[this.scale-1]){
		explosion(this.x,this.y);
		if (this.scale > 2){
		    scene.push(new Roid(this.x,this.y,this.scale-1));
		    scene.push(new Roid(this.x,this.y,this.scale-1));
		}
		scene.splice(scene.indexOf(this),1);
		missiles[m].ttl = 0;
		if (missiles[m].type != "badmissile"){
		    ship.addPoints(roidPoints[this.scale]);
		}
		return false;
	    }
	}
	// Player collision detect
	var prox = Math.sqrt(Math.pow(this.x - ship.x,2) +
			     Math.pow(this.y - ship.y,2));
	if (Math.abs(prox) < (4 * scalers[this.scale-1]) + 4){
	    playerKill();
	}
	return true;
    };
}

// GALAG BADDIE ===================
var galag1Coords = [
	[[-10,2,0],[4,-2,6],[2,-4,6],[4,-2,6],[4,2,6],[2,4,6],[4,2,6],
	 [-6,0,0],[2,4,6],[-4,4,6],
	 [0,-8,0],[-2,4,6],[-2,-4,6],
	 [-2,0,0],[-2,4,6],[4,4,6]],
	[[-10,2,0],[4,-2,6],[2,-4,6],[4,-2,6],[4,2,6],[2,4,6],[4,2,6],
	 [-6,0,0],[4,2,6],[-2,4,6],
	 [-4,-4,0],[-2,4,6],[-2,-4,6],
	 [-2,-2,0],[-4,2,6],[2,4,6]],
];
var galag1Paths = [
    [[4,0,0,80],[3,1,0,5],[1,2,0,3],[-4,0,0,80],[-3,1,0,5],[-1,2,0,3]],
    [[0,5,0,40],[0,5,Math.PI/20,19],[0,5,0-(Math.PI/40),79],[0,5,0-(Math.PI/15),14]]
];
function galag1(x,y,d){
    this.type = "galag01";
    this.pointValue = 100;
    this.x = 640; // || parseInt(screenWidth/2);
    this.y = 0;
    this.delay = d || 1;
    this.startingPath = [[0,10,Math.PI/50,24], // 90 swoop left
			 [0,15,0 - Math.PI/50,74], // 360 swoop ccw
			 [0,18,0 - Math.PI/50,24],
			 [0,12,0 - Math.PI/30,29],
			 [0,10,0 - Math.PI/20,19],
			 [0,8,0 - Math.PI/20,9],
			 [(x - 480) / (90 - (d % 90)),
			  (y - 200) / (90 - (d % 90)),0,
			  (90 - (d % 90))]];
    this.rot = 0;
    this.rotSpeed = this.startingPath[0][2];
    this.coords = galag1Coords[0];
    this.framectr = [0,0]; // [Frame delay,Frame number]
    this.rotcoords = [];
    this.inertiaX = 0;
    this.inertiaY = 0;
    this.flightpath = this.startingPath;
    this.flightpathix = 0;
    this.flightstep = 0;
    this.stepdelay = 0;
    this.dprog = [];
    this.displayProgram = function(){
	if (this.delay > 0) {
	    return [];
	};
	this.coords = galag1Coords[this.framectr[1]];
//	this.rotcoords = galag1Coords[this.framectr[1]];
	this.rotcoords = [];
	for (var c in this.coords){
	    this.rotcoords.push(rot([this.coords[c][0],
				     this.coords[c][1]],
				    this.rot));
	}	
	this.dprog = [new vecOp("LABS",
			       parseInt(this.x),
			       parseInt(this.y),
			       1)];
	for (var c in this.rotcoords){
	    this.dprog.push(new vecOp("VCTR",
				      parseInt(this.rotcoords[c][0]*1.5),
				      parseInt(this.rotcoords[c][1]),
				      1,
				      this.coords[c][2]));
	}
	return this.dprog;
    };
    this.update = function(){
	if (this.delay > 0){
	    this.delay--;
	    return;
	}
	if(Math.random() > 0.999){
	    missiles.push(BadMissile(this.x,this.y,this.rot + Math.PI));
	}
	this.rot += this.rotSpeed;
	this.rot = this.rot % 6.28;
	// Animation stuff
	this.framectr[0]++;
	if(this.framectr[0] == 5){
	    this.framectr[1] = (this.framectr[1] + 1) % galag1Coords.length;
	    this.framectr[0] = 0;
	}
	// Flight path stuff
	this.stepdelay++;
	if (this.stepdelay > this.flightpath[this.flightstep][3]){
	    this.stepdelay = 0;
	    this.flightstep = (this.flightstep + 1) % this.flightpath.length;
	    // If at end of path, maybe we change path?
	    if ((this.flightpath == this.startingPath) &&
		(this.flightstep == 0)){
		this.flightpath = galag1Paths[this.flightpathix];
	    }
	    else if( (this.flightstep == 0) &&
		     (Math.random() > 0.8) ){
		this.flightpathix = (this.flightpathix + 1) % galag1Paths.length;
		this.flightpath = galag1Paths[this.flightpathix];
	    }
	    this.rotSpeed = this.flightpath[this.flightstep][2];
	    if (Math.abs(this.rot) < 0.05) { this.rot = 0;}
	}
	var inerts = rot([this.flightpath[this.flightstep][0],
			  this.flightpath[this.flightstep][1]],
			 this.rot);
	this.inertiaX = inerts[0];
	this.inertiaY = inerts[1];
//	this.inertiaX = this.flightpath[this.flightstep][0];
//	this.inertiaY = this.flightpath[this.flightstep][1];
	this.x = wrapX(this.x + this.inertiaX);
	this.y = wrapY(this.y + this.inertiaY);
	//Missile collision detect
	for (var m in missiles){
	    if (missiles[m].ttl == 0){continue;};
	    if (missiles[m].type == "badmissile"){continue;};
	    if (Math.abs(Math.sqrt(Math.pow(this.x - missiles[m].x,2) +
				   Math.pow(this.y - missiles[m].y,2))) < 16){
		explosion(this.x,this.y);
		scene.splice(scene.indexOf(this),1);
		missiles[m].ttl = 0;
		ship.addPoints(this.pointValue);
		return false;
	    }
	}
	// Player collision detect
	//if (Math.abs(Math.sqrt(Math.pow(this.x - ship.x,2) +
	//		       Math.pow(this.y - ship.y,2))) < 8){
	if (ship.x < (this.x + 15) &&
	    ship.x > (this.x - 15) &&
	    ship.y < (this.y + 8) &&
	    ship.y > (this.y - 8)){
	    playerKill();
	}
	return true;
    };
}

// UFO SAUCER (STUPID)
function Ufoe(){
    this.type = "saucer";
    this.pointValue = 200;
    this.scale = 2;
    this.aim = "bad";
    this.x = 0;
    this.y = parseInt(Math.random() * 720);
    this.coords = [[-8,1,0],
		   [16,0,8],[-5,3,8],[-6,0,8],[-5,-3,8],
		   [5,-2,8],[6,0,8],[5,2,8],
		   [-5,-2,0],
		   [-2,-3,8],[-2,0,8],[-2,3,8]];
    this.inertiaX = (Math.random() > 0.5) ?
	2 + (2 * challenge) : -2 - (2 * challenge);
    this.inertiaY = 2 - parseInt(Math.random()*4);
    this.displayProgram = function(){
	//this.coords = galag1Coords[this.framectr[1]];
	var dprog = [new vecOp("LABS",
			       parseInt(this.x),
			       parseInt(this.y),
			       this.scale)];
	for (var c in this.coords){
	    dprog.push(new vecOp("VCTR",
				 parseInt(this.coords[c][0]),
				 parseInt(this.coords[c][1]),
				 1,
				 this.coords[c][2]));
	};
	// Rotating window/sensor/whatever
	dprog.push(new vecOp("VCTR",8-(ship.livetime % 16),2,1,0));
	dprog.push(new vecOp("VCTR",0,1,1,12));
	return dprog;
    };
    this.update = function(){
	if((this.x + this.inertiaX) < 1 ||
	   (this.x + this.inertiaX) > (screenWidth-1)){
	    if (Math.random() > 0.5 + (0.45 * challenge)){
		scene.splice(scene.indexOf(this),1);
	    }
	}
	this.x = wrapX(this.x + this.inertiaX);
	this.y = wrapY(this.y + this.inertiaY);

	// Fire a missile?
	if(Math.random() > (0.99 - (challenge * 0.009))){
	    var shotAngle;
	    if(this.aim == "bad"){
		shotAngle = Math.random()*6.28;
	    } else {
		//shotAngle = (Math.PI/2) +
		shotAngle =    Math.atan2(  (this.x - 480) - (ship.x - 480),
			      (this.y - 360) - (ship.y - 360));
	    }
	    missiles.push(BadMissile(this.x,this.y,shotAngle));
	    this.inertiaY = 2 - parseInt(Math.random()*4);
	}
	
	//Missile collision detect
	for (var m in missiles){
	    if (missiles[m].type == "badmissile"){continue;};
	    if (missiles[m].ttl == 0){continue;};
	    var prox = Math.sqrt(Math.pow(this.x - missiles[m].x,2) +
				 Math.pow(this.y - missiles[m].y,2));
	    if (Math.abs(prox) < (8 * this.scale)){
		explosion(this.x,this.y);
		scene.splice(scene.indexOf(this),1);
		missiles[m].ttl = 0;
		ship.addPoints(this.pointValue);
		return false;
	    }
	}
	// Player collision detect
	var prox = Math.sqrt(Math.pow(this.x - ship.x,2) +
			     Math.pow(this.y - ship.y,2));
	if (Math.abs(prox) < 8 * this.scale){
	    playerKill();
	}
	return true;
    };
}
LittleUfoe.prototype = new Ufoe();
function LittleUfoe(){
    Ufoe.apply(this);
    this.scale = 1;
    this.pointValue = 1000;
    this.aim = "good";
}

function wrapY(y){
    if (y <= 0){
	return y + screenHeight;
    } else if (y > screenHeight){
	return y - screenHeight;
    }
    return y;
}
function wrapX(x){
    if (x <= 0){
	return (x + screenWidth);
    } else if (x > screenWidth) {
	return (x - screenWidth);
    }
    return x;
}

var rotCos,rotSin;
function rot(coords,r){
    rotCos = Math.cos(r);
    rotSin = Math.sin(r);
    return [coords[0] * rotCos - coords[1] * rotSin,
	    coords[1] * rotCos + coords[0] * rotSin,
	    coords[2]];
}
function playerKill(){
    explosion(ship.x,ship.y);
    ship.alive = false;
    ship.lives--;
    ship.x = -999;
    scene.splice(scene.indexOf(ship),1);
    if (ship.lives == 0){
	gameOver();
    } else {
	scene.push(warpPrompt);
    }
}
function playerWarpIn(){
    ship.x = screenWidth / 2;
    ship.y = screenHeight / 2;
    ship.power = 3;
    ship.inertiaX = 0;
    ship.inertiaY = 0;
    ship.rot = 0;
    ship.alive = true;
    scene.splice(scene.indexOf(warpPrompt),1);
    scene.unshift(ship);
}

function newGame(){
    scene = [];
    missiles = [];
    ship.addPoints(0 - ship.points);
    ship.livetime = 0;
    ship.lives = 3;
    initAsteroids();
    playerWarpIn();
}

function gameOver(){
    mode = "attract";
    scene.push(attractCard);
}
function initAsteroids(){
    mode = "asteroids";
    stageTime = 0;
    maxRoids = 5 + Math.min(7,parseInt(7 * challenge));
    for (var ax = 0; ax < maxRoids; ax++){
	scene.push(new Roid());
    }
    scene.push(new TimeoutMessage("entering asteroid field",null,600));
    scene.push(new StarSpeed(0.9615384615384615));
}

function initGalaga(){
    mode = "galaga";
    stageTime = 0;
    scene.push(new galag1(210,50,0));
    scene.push(new galag1(310,50,8));
    scene.push(new galag1(410,50,16));
    scene.push(new galag1(510,50,24));
    scene.push(new galag1(610,50,32));
    scene.push(new galag1(710,50,40));
    scene.push(new galag1(210,110,120));
    scene.push(new galag1(310,110,128));
    scene.push(new galag1(410,110,136));
    scene.push(new galag1(510,110,144));
    scene.push(new galag1(610,110,152));
    scene.push(new galag1(710,110,160));
    if (challenge > 0.1){
    scene.push(new galag1(210,160,480));
    scene.push(new galag1(310,160,488));
    scene.push(new galag1(410,160,496));
    scene.push(new galag1(510,160,504));
    scene.push(new galag1(610,160,512));
    scene.push(new galag1(710,160,520));
    }
    scene.push(new TimeoutMessage("galxon formation approaching",null,600));
    scene.push(new StarSpeed(1.04));
}
var frameSkip = 0;
// ==================================================================
// = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = 
function mainLoop(){
    requestAnimationFrame(mainLoop);

    frameSkip = (frameSkip + 1) % 2;
    if (frameSkip == 1) return;

    // Paused?
    if (HALT_FLAG == 1) return;

    //var t1 = performance.now();
    
    ship.livetime++;
    stageTime++;
    
    // Maximum difficulty after 10 minutes (36000 frames);
    challenge = Math.min(1,ship.livetime/36000);

    // Beep / heartbeat / "music"
    if (mode == "asteroids"){
	// 5400 frames =  3 minutes
	if (stageTime % (60 - parseInt(30 * Math.min(1,stageTime/5300))) == 0){
	    sfx.beep.currentTime = 0;
	    sfx.beep.play();
	}
    }
    // Is the scene clear?
    if (scene.length < 2){
	if (mode == "galaga" || mode == "attract"){
	// More asteroids?
	    //	if (Math.random() > 0.5){
	    initAsteroids();
	// Or some Galaxians?
	}else {
	    initGalaga();
	}
    }
    // Make new DVG program
    program = new Array();
    for (var op in missiles){
	program = program.concat(missiles[op].displayProgram());
    }
    for (var op in scene){
	program = program.concat(scene[op].displayProgram());
    }
    for (var op in starfield){
	program = program.concat(starfield[op].displayProgram());
    }
    // Update score
    program = program.concat(scoreVector);
    program = program.concat(vectorString(ship.lives.toString(),20,50));
    program.push(new vecOp("JMPL",0));

    // Handle some user input
    if (controls["right"]){
	ship.rot += 0.14159;
	ship.rot = ship.rot % 6.28;
    }
    if (controls["left"]){
	ship.rot -= 0.14159;
	ship.rot = ship.rot % 6.28;
    }    
    if (controls["thrust"]){
	ship.inertiaX += Math.sin(ship.rot) * (0.2 + (challenge * 0.3));
	ship.inertiaY += (0 - Math.cos(ship.rot)) * (0.2 + (challenge * 0.3));
	
	if (Math.abs(ship.inertiaX) > maxShipSpeed) {
	    ship.inertiaX = (ship.inertiaX > 0) ?
		maxShipSpeed : 0 - maxShipSpeed;
	}
	if (Math.abs(ship.inertiaY) > maxShipSpeed) {
	    ship.inertiaY = (ship.inertiaY > 0) ?
		maxShipSpeed : 0 - maxShipSpeed;
	}
    }

    // Update scene objects
    for (var op in scene) { scene[op].update(); }
    for (var op in missiles) {missiles[op].update(); }

    // Move stars
    for (var op in starfield) {starfield[op].update();}

    if (mode == "asteroids"){
	// Spawn a saucer?
	if (Math.random() < (0.01 * challenge)){
	    if (Math.random() < (0.5 * challenge)){
		scene.push(new LittleUfoe());
	    } else {
		scene.push(new Ufoe());
	    }
	}
    }
    //var t2 = performance.now();
    //mainTime.textContent=(t2-t1).toFixed(4);

    // Draw the scene.
    runDVG();
}

// Setting these globally since they shouldn't be changed
// By the program at any point. 
DVG.lineJoin = "round";
DVG.lineCap = "round";
var imData = DVG.getImageData(0,0,screenWidth,screenHeight);
function runDVG(){
    //var t1 = performance.now();

    // phosphor fade-out
    DVG.globalCompositeOperation = "source-over";
    //DVG.globalCompositeOperation = "overlay";
    DVG.fillStyle = "rgba(0,0,0,"+ pDecay+ ")";
    DVG.fillRect(0,0,canvasElement.width,canvasElement.height);
    //DVG.drawImage(bgimg,0,0);

    // EFFECT
    /* 
    imData = DVG.getImageData(0,0,320,240);
    var lastGreen = 0;
    var nextRed = 0;
    for (var pixl = 8; pixl < (imData.data.length * 2)-8; pixl += 4){
	
	nextRed = imData.data[pixl+8];
	imData.data[pixl] = nextRed;
    }
    for (var pixl = (imData.data.length * 2) - 8; pixl > 8; pixl -= 4){
	lastGreen = imData.data[pixl-7];
	imData.data[pixl+1] = lastGreen;
    }
    DVG.putImageData(imData,0,0);
    */
    
    // Prepare the context for drawing
    //DVG.lineJoin = "round";
    //DVG.lineCap = "round";
    DVG.globalCompositeOperation = "lighter";
         
    // Now we'll start to run the program, but only perform the number
    // of operations in maxOps.
    DVG.beginPath();

    // Move the beam to the last-known X,Y coordinates. This is for
    // picking-up where we left-off when maxOps is less than the
    // length of the program.
    DVG.moveTo(lastPoint.x,lastPoint.y);

    // Length of the program may be different from the last time through,
    // so make sure our pointer is in-bounds.
    if (pc >= program.length) { pc = 0; };

    // Glitch-checking. If we're starting the loop with a nonzero
    // program counter, skip ahead to the next LABS command so that we
    // don't start drawing unfinished vectors from the wrong origin.
    if (pc > 0){
	while (program[pc].opcode != "LABS"){
	    pc = (pc + 1) % program.length;
	}
    }

    // Adjust maxOps so that we have enough vector operations to finish the
    // display program, plus a little extra for "shimmer". The shimmer value
    // causes over-drawing of vectors, which also makes things look "hot" when
    // there are only a few objects on screen.
    maxOps = program.length + shimmer;

    for (var ops = 0; ops < maxOps; ops++){
	thisOp = program[pc];
	switch (thisOp.opcode) {
	case "LABS": // [L]oad [ABS]olute
	    // Deflect the beam to a specific coordinate on the
	    // screen, drawing nothing; set the global scale factor.
	    DVG.moveTo(parseInt(thisOp.x + (Math.random() * jitter)),
		       parseInt(thisOp.y + (Math.random() * jitter)));
	    SCALE_FACTOR = thisOp.scale;
	    // Save our deflection in case we have to resume the
	    // program on another iteration of main_loop();
	    lastPoint.x = thisOp.x;// + (2 - parseInt(Math.random() *4));
	    lastPoint.y = thisOp.y;// + (2 - parseInt(Math.random() *4));
	    break;
	case "VCTR": // Draw long [V]e[CT]o[R]
	    // Draw a vector at the specified intensity. Coordinates
	    // are relative to the current deflection, and are divided
	    // by 2^divisor, then multiplied according to the global
	    // scale factor.
	    var relX = parseInt( thisOp.x * scalers[SCALE_FACTOR] / divisors[thisOp.divisor] );
	    var relY = parseInt( thisOp.y * scalers[SCALE_FACTOR] / divisors[thisOp.divisor] );
	    if (thisOp.intensity == 0){
		// An intensity 0 operation is treated like a LABS operation, because
		// there is a performance penalty for calling glowStroke(), which has
		// to be done whenever we change intensity.
		lastPoint.x += relX; // Save where our deflection will
		lastPoint.y += relY;  // be at the end of this vector.
		DVG.moveTo(lastPoint.x,lastPoint.y);
	    } else {
		if (thisOp.intensity != lastIntensity){
		    glowStroke();  // Draw whatever's on the path right now,
		    // because we need to start a new path for this new
		    // intensity.
		    lastIntensity = thisOp.intensity;
		    DVG.beginPath();  // Begin a new path at last
		                      // deflection...
		    DVG.moveTo(lastPoint.x,lastPoint.y);
		}
		lastPoint.x += relX; // Save where our deflection will
		lastPoint.y += relY;  // be at the end of this vector.
		DVG.lineTo(lastPoint.x + (Math.random() * jitter),
			   lastPoint.y + (Math.random() * jitter));
	    }
	    break;
	case "SVEC" : // [S]hort [VEC]tor
	    // Similar to VCTR, but with a less-precise way of
	    // specifying length.  

	    // Valid values for x and y are 0 - 3, or 00b - 11b. The
	    // scale factor (also ranging from 0 to 3) determines
	    // whether to shift this value left by 4, 5, 6, or 7 bits.
	    var relX = thisOp.x << (4 + thisOp.scale);
	    var relY = thisOp.y << (4 + thisOp.scale);

	    if (thisOp.intensity != lastIntensity){
		glowStroke();
		lastIntensity = thisOp.intensity;
		DVG.beginPath();
		DVG.moveTo(lastPoint.x,lastPoint.y);
	    }
	    lastPoint.x += relX;
	    lastPoint.y += relY; 
	    DVG.lineTo(lastPoint.x + parseInt(Math.random() * 4),lastPoint.y);
	    break;
	case "JMPL" : // [J]u[MP]...[L]arry?
	    // Nothing special here. Change program counter to the
	    // target and exit the loop without incrementing it.
	    pc = thisOp.target;
	    continue;
	    break;
	case "JSRL" : // [J]ump to [S]ub[R]outine, [L]
            pc++;
	    stack.push(pc);
	    pc = thisOp.target;
	    continue;
	    break;
	case "RTSL" : // [R]e[T]urn from [S]ubroutine,[L]
	    pc = stack.pop();
	    continue;
	    break;
	case "HALT" :
	    HALT_FLAG = 1;
	    return;
	    break;
	}

	pc++;
	//pc = (HALT_FLAG == 0) ? pc + 1 : pc;
    }

    glowStroke();

    //var t2 = performance.now();
    //dvg_time.textContent = (t2-t1).toFixed(4);
}
function vecOp(opcode,a1,a2,a3,a4){
  // VCTR, LABS, HALT, JSRL, RTSL, JMPL, SVEC
    this.opcode = opcode || "HALT";
    if (this.opcode == "VCTR"){
	this.x = parseInt(a1) || 0;
	this.y = parseInt(a2) || 0;
        this.divisor = parseInt(a3) || 1;
	this.intensity = parseInt(a4) || 0;
    } else if (this.opcode == "SVEC"){
	this.x = parseInt(a1) || 0;
	this.y = parseInt(a2) || 0;
	this.scale = parseInt(a3) || 0;
	this.intensity = parseInt(a4) || 0;
    } else if (this.opcode == "LABS"){
	this.x = parseInt(a1) || 0;
	this.y = parseInt(a2) || 0;
	this.scale = parseInt(a3) || 1;
    } else if ((this.opcode == "JSRL") || (this.opcode == "JMPL")){
	this.target = parseInt(a1);
    }
}

function glowStroke(){
  // Draw the vector three times, to build-up a glow-like effect.
    /*DVG.lineWidth = intWidths3[lastIntensity] + (Math.random() * 2);
    DVG.strokeStyle = 'rgba(127,228,255,' + intBright3[lastIntensity] + ")";
    DVG.stroke();*/
    DVG.lineWidth = intWidths2[lastIntensity];// + Math.random();
    DVG.strokeStyle = 'rgba(127,228,255,' + intBright2[lastIntensity] + ")";
    DVG.stroke();
    DVG.lineWidth = intWidths1[lastIntensity];
    DVG.strokeStyle = 'rgba(127,228,255,' + intBright1[lastIntensity] + ")";
    DVG.stroke(); 
}

function parseProgram(){
  var editor = document.getElementById("progEditor");
  var code = editor.value;
  var newProg = new Array();
  var codeLines = code.split(/\n/);
  var codeLabels = new Object();
  var opNum = 0;
  var errs = 0;

  // Run through once and get all the label addresses
  for (var lineNum in codeLines){
    codeLines[lineNum].trim();
    var splitLine = codeLines[lineNum].split(/\s+/);
    if (splitLine[0] == "LABEL"){
      codeLabels[splitLine[1]] = opNum;
      continue;
    } else if ((splitLine[0] == "VCTR") ||
	       (splitLine[0] == "LABS") ||
	       (splitLine[0] == "HALT") ||
	       (splitLine[0] == "JSRL") ||
	       (splitLine[0] == "RTSL") ||
	       (splitLine[0] == "JMPL") ||
	       (splitLine[0] == "SVEC")){
      opNum++;
    }
  }

    // Run through again, actually generating the vecOp and pushing it
    // onto a new program this time.
    opNum = 0;
    for (var lineNum in codeLines){
	codeLines[lineNum].trim();
	var splitLine = codeLines[lineNum].split(/\s+/);
	if (splitLine[0] == "VCTR") {
	    var newOp = new vecOp("VCTR",splitLine[1],splitLine[2],splitLine[3],splitLine[4]);
	} else if (splitLine[0] == "LABS"){
	    var newOp = new vecOp("LABS",
				  512 + parseInt(splitLine[1]),
				  512 + parseInt(splitLine[2]),
				  splitLine[3]);
	} else if (splitLine[0] == "HALT"){
	    var newOp = new vecOp("HALT");
	} else if (splitLine[0] == "JSRL"){
	    var newOp = new vecOp("JSRL",codeLabels[splitLine[1]]);
	} else if (splitLine[0] == "RTSL"){
	    var newOp = new vecOp("RTSL");
	} else if (splitLine[0] == "JMPL"){
	    var newOp = new vecOp("JMPL",
				  codeLabels[splitLine[1]]);
	} else if (splitLine[0] == "SVEC"){
	    var newOp = new vecOp("SVEC",
				  splitLine[1],
				  splitLine[2],
				  splitLine[3],
				  splitLine[4]);
	} else {
	// If there's no opcode at the start of the line, treat it like a 
	// comment and ignore it.
	    continue;
	}
	opNum++;
	newProg.push(newOp);
    }
    if (errs == 0) {
	program = newProg;
	pc = 0;
    }
    
}
function Sfx(audioFile){
    this.soundFile = audioFile;
    this.soundIx = 0;
    this.sounds = [ new Audio(this.soundFile)];
    this.sounds[0].play();
    this.play = function(){
	this.soundIx++;
	this.soundIx = this.soundIx % this.sounds.length;
	// Push a new Audio element to the array if we
	// need one.
	if (this.sounds[this.soundIx].ended == false){
	    this.sounds.push(this.sounds[0].cloneNode(true));
	    this.soundIx = this.sounds.length - 1;
	} else {
	    //alert(this.sounds[this.soundIx]);
	    this.sounds[this.soundIx].currentTime = 0;
	}
	this.sounds[this.soundIx].play();
    }
}
var sfxBoom = new Sfx('boom.mp3');
var sfxShot = new Sfx('laser.mp3');

function explosion(x,y){
    sfxBoom.play();
    scene.push(new Particle(x,y));
    scene.push(new Particle(x,y));
    scene.push(new Particle(x,y));
    scene.push(new Particle(x,y));
    scene.push(new Particle(x,y));
    scene.push(new Particle(x,y));
    scene.push(new Particle(x,y));
    scene.push(new Particle(x,y));
    scene.push(new Particle(x,y));
    scene.push(new Particle(x,y));
}

function mouseHandle(evt){
  tailsX.push(evt.clientX);
  tailsY.push(evt.clientY);
}

function keyUp(evt){
    switch (evt.which){
    case 88 : // X
	controls["right"] = false;
	break;
    case 68 : // D
	controls["right"] = false;
	break;
    case 90 : // Z
	controls["left"] = false;
	break;
    case 65 : // A
	controls["left"] = false;
	break;
    case 191: // Slash
	controls["thrust"] = false;
	sfx.thrust.pause();
	break;
    case 222: // [']
	controls["thrust"] = false;
	sfx.thrust.pause();
	break;
    }
}
function thrust(){
	controls["thrust"] = true;
	sfx.thrust.currentTime = 0;
	sfx.thrust.play();
	evt.preventDefault();
}
function fire(){
    if(ship.power > 0 && ship.alive){
	missiles.push(new Missile(ship.x,ship.y,ship.rot));
	ship.power--;
	sfxShot.play();
	//sfx.shot.cloneNode(true).play();
    }
}
function warp(){
    // Warp!  New ship at the centre of the screen, or new game.
    if (!ship.alive){
	if (ship.lives > 0){
	    playerWarpIn();
	} else {
	    newGame();
	}
    } else {
	ship.x = parseInt(Math.random()*screenWidth);
	ship.y = parseInt(Math.random()*screenHeight);
    }
}

function keyHandle(evt){
    // Catch some keypresses, do some stuff.
    switch (evt.which){
    case 72 : // H
	var overlay = document.getElementById("overlay");
	overlay.style.display = (overlay.style.display == "none") ? "inline-block" : "none"; 
	break;
    case 80 : // P
	HALT_FLAG = (HALT_FLAG == 0) ? 1 : 0;
	break;
    case 88 : // X
	controls["right"] = true;
	break;
    case 90 : // Z
	controls["left"] = true;
	break;
    case 68 : // D
	controls["right"] = true;
	break;
    case 65 : // A
	controls["left"] = true;
	break;
    case 16 : // Shift
	fire();
	break;
    case 13 : // Enter
	fire();
	break;
    case 190 : // Period
	explosion(ship.x,ship.y);
	break;
    case 191 : // Slash
	evt.preventDefault();
	thrust();
	break;
    case 97 : // Numpad 1
	scene.push(new LittleUfoe());
	break;
    case 222 : // [']
	evt.preventDefault();
	thrust();
	break;
    case 32 : // [SPACE]
	warp();
	break;
    case 49 : // [1]
	warp();
	break;

    }
    if (evt.ctrlKey){
	switch (evt.which) {
	case 190: // [>] 
	    maxOps++;
	    break;
	case 188: // [<]
	    maxOps--;
	    break;
	case 219: // [ [ ]
	    pDecay -= 0.05;
	    break;
	case 221: // [ ] ]
	    pDecay += 0.05;
	    break;
	}
    }
}

window.addEventListener("keydown",keyHandle,true);
window.addEventListener("keyup",keyUp,true);
window.addEventListener("load",mainLoop);
